/*
 *	spComponent_Gtk.h
 */

#ifndef __SPCOMPONENT_GTK_H
#define __SPCOMPONENT_GTK_H

#include <gtk/gtk.h>

#include <sp/spComponentDefs.h>

#ifdef __cplusplus
extern "C" {
#endif

#ifndef GTK_CHECK_VERSION
#define GTK_CHECK_VERSION(major,minor,micro)    \
    (GTK_MAJOR_VERSION > (major) || \
     (GTK_MAJOR_VERSION == (major) && GTK_MINOR_VERSION > (minor)) || \
     (GTK_MAJOR_VERSION == (major) && GTK_MINOR_VERSION == (minor) && \
      GTK_MICRO_VERSION >= (micro)))
#endif

#define SP_DEFAULT_SPACING 10
#define SP_DEFAULT_MARGIN 10
#define SP_DEFAULT_DIALOG_MARGIN 5
#define SP_DEFAULT_DIALOG_BUTTON_MARGIN 12
#define SP_DEFAULT_DIALOG_BUTTON_SPACING 12
#define SP_DEFAULT_BUTTON_WIDTH 86
#define SP_DEFAULT_BUTTON_HEIGHT 26
#define SP_DEFAULT_LABEL_WIDTH 86
#define SP_DEFAULT_LABEL_HEIGHT 26
#define SP_DEFAULT_TEXT_WIDTH 120
#define SP_DEFAULT_TEXT_HEIGHT 26
#define SP_DEFAULT_TEXT_AREA_WIDTH 200
#define SP_DEFAULT_TEXT_AREA_HEIGHT 200
#define SP_DEFAULT_LIST_WIDTH 120
#define SP_DEFAULT_LIST_HEIGHT 120
#define SP_DEFAULT_SLIDER_LENGTH 200
#define SP_DEFAULT_SLIDER_WIDTH 15
#define SP_DEFAULT_TRACKBAR_LENGTH SP_DEFAULT_SLIDER_LENGTH
#define SP_DEFAULT_HORIZONTAL_TRACKBAR_WIDTH 40
#define SP_DEFAULT_VERTICAL_TRACKBAR_WIDTH 50
#define SP_DEFAULT_MENU_BAR_HEIGHT 28
#define SP_DEFAULT_TOOL_ITEM_MARGIN 2
#define SP_DEFAULT_TOOL_ITEM_SPACING 0
#define SP_DEFAULT_TOOL_SEPARATOR_WIDTH 5
#define SP_DEFAULT_STATUS_BAR_HEIGHT 25
/*#define SP_DEFAULT_TAB_HEIGHT 22*/
/*#define SP_DEFAULT_TAB_HEIGHT 26*/
#define SP_DEFAULT_TAB_HEIGHT 25
    
#define SP_CALLBACK_BUFFER 16

#ifdef __cplusplus
}  /* Close scope of 'extern "C"' declaration */
#endif

#endif /* __SPCOMPONENT_GTK_H */
