Summary: MPEG audio I/O Library 
Name: spMpeg
Version: 0.8.3
Release: 3
Copyright: LGPL
Distribution: (none)
Vendor: (none)
Group: Libraries
Source: spMpeg-0.8.3-3.tgz
Source1: bladeenc-0.94.2-src-stable.tar.gz
Packager: Hideki Banno <banno@itakura.nuee.nagoya-u.ac.jp>
URL: http://www.itakura.nuee.nagoya-u.ac.jp/people/banno/spLibs/index.html
BuildRoot: /var/tmp/spMpeg-root
Requires: spBase >= 0.8.8, spAudio >= 0.7.4

%package iplugin
Summary: an input plugin for MPEG audio files.
Group: Applications/Sound

%package oplugin
Summary: an output plugin for MPEG audio files.
Copyright: not distributable
Group: Applications/Sound

%description
spMpeg is MPEG audio I/O library which is a part of spLibs
(http://www.itakura.nuee.nagoya-u.ac.jp/people/banno/spLibs/). 

%description iplugin
This is an input plugin for MPEG audio files.

%description oplugin
This is an output plugin for MPEG audio files. 

%changelog
* Tue Mar 13 2001  Hideki Banno <banno@itakura.nuee.nagoya-u.ac.jp>
- Version 0.8.3

* Thu Dec 14 2000  Hideki Banno <banno@itakura.nuee.nagoya-u.ac.jp>
- Version 0.8.2

* Sun Oct  8 2000  Hideki Banno <banno@itakura.nuee.nagoya-u.ac.jp>
- Version 0.8.1

* Tue Aug 15 2000  Hideki Banno <banno@itakura.nuee.nagoya-u.ac.jp>
- 1st release

%prep
%setup
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT/usr
%setup -D -a 1 -T


%build
cd bladeenc-0.94.2
./configure
make
cd ..

if [ -f $RPM_SOURCE_DIR/lame3.70.tar.gz ]; then
    tar zxvf $RPM_SOURCE_DIR/lame3.70.tar.gz
fi

cd spMpeg

make MPEGTOP=$RPM_BUILD_ROOT/usr TOP=/usr clean
if [ -d ../lame3.70 ]; then
    ln -s ../lame3.70 lame
fi
ln -s ../bladeenc-0.94.2/bladeenc
make MPEGTOP=../.. TOP=/usr

cd ..

%install
cd spMpeg
make MPEGTOP=../.. TOP=/usr SPDESTROOT=$RPM_BUILD_ROOT/usr install
make MPEGTOP=../.. TOP=/usr SPDESTROOT=$RPM_BUILD_ROOT/usr install.hdr

cd input_mpeg
make MPEGTOP=$RPM_BUILD_ROOT/usr TOP=/usr PLUGINDEST="" SPDESTROOT=$RPM_BUILD_ROOT/usr install
cd ..

cd output_mpeg
make MPEGTOP=$RPM_BUILD_ROOT/usr TOP=/usr PLUGINDEST="" SPDESTROOT=$RPM_BUILD_ROOT/usr install
cd ..
if [ -d lame ]; then
    cd output_lame
    make MPEGTOP=$RPM_BUILD_ROOT/usr TOP=/usr PLUGINDEST="" SPDESTROOT=$RPM_BUILD_ROOT/usr install
    cd ..
    cp output_lame/LICENSE_LAME.txt .
fi

cd ..

if [ -f $RPM_BUILD_ROOT/usr/lib/libspmpeg.linux-glibc.a ]; then
    cd $RPM_BUILD_ROOT/usr/lib
    ln -s libspmpeg.linux-glibc.a libspmpeg.linux.a
fi
if [ -f $RPM_BUILD_ROOT/usr/lib/libspmpege.linux-glibc.a ]; then
    cd $RPM_BUILD_ROOT/usr/lib
    ln -s libspmpege.linux-glibc.a libspmpege.linux.a
fi
if [ -f $RPM_BUILD_ROOT/usr/lib/libspmpegel.linux-glibc.a ]; then
    cd $RPM_BUILD_ROOT/usr/lib
    ln -s libspmpegel.linux-glibc.a libspmpegel.linux.a
fi

%clean
rm -rf $RPM_BUILD_ROOT

%pre
%post
%preun
%postun

%files 
%doc spMpeg/README* spMpeg/CHANGES* spMpeg/LICENSE*
/usr/lib/*.a

%files iplugin
%doc spMpeg/LICENSE*
/usr/lib/sp/plugins/input_mpeg.so

%files oplugin
%doc spMpeg/LICENSE* spMpeg/output_mpeg/README*
/usr/lib/sp/plugins/output_*.so
