#   File:       spMpegEncode-ppc.make
#   Target:     spMpegEncode-ppc
#   Created:    Sunday, October 8, 2000 05:02:26 PM


MAKEFILE        = spMpegEncode-ppc.make
# MondoBuild    = {MAKEFILE}  # Make blank to avoid rebuilds when makefile is modified
MondoBuild    =

SpBaseDir       = ::spBase:
SpAudioDir      = ::spAudio:
SpLibDir  	= ::lib:

ObjDir          = :bladeenc:
Includes        =  
				  -i : 
				  -i {SpAudioDir} 
				  -i {SpBaseDir}

Sym-PPC         = -sym off

PPCCOptions     = {Includes} {Sym-PPC}  -includes unix -enum int -d inline="" -d SYSTEM=MAC_OS -d TARGET_OS_MAC


### Source Files ###

SrcFiles        =  
				  mpegEncode.c 
				  :bladeenc:bladesys.c :bladeenc:bladtab.c 
				  :bladeenc:common.c :bladeenc:encode.c :bladeenc:formatbitstream2.c 
				  :bladeenc:huffman.c :bladeenc:l3bitstream.c :bladeenc:l3psy.c 
				  :bladeenc:loop.c :bladeenc:mdct.c :bladeenc:codec.c :bladeenc:reservoir.c 
				  :bladeenc:strupr.c :bladeenc:subs.c :bladeenc:tables.c

### Object Files ###

ObjFiles-PPC    =  
				  "{ObjDir}mpegEncode.c.x" 
				  "{ObjDir}bladesys.c.x" "{ObjDir}bladtab.c.x" 
				  "{ObjDir}common.c.x" "{ObjDir}encode.c.x" "{ObjDir}formatbitstream2.c.x" 
				  "{ObjDir}huffman.c.x" "{ObjDir}l3bitstream.c.x" "{ObjDir}l3psy.c.x" 
				  "{ObjDir}loop.c.x" "{ObjDir}mdct.c.x" "{ObjDir}codec.c.x" "{ObjDir}reservoir.c.x" 
				  "{ObjDir}strupr.c.x" "{ObjDir}subs.c.x" "{ObjDir}tables.c.x"


### Libraries ###

LibFiles-PPC    = 


### Default Rules ###

.c.x    .c  {MondoBuild}
	{PPCC} {depDir}{default}.c -o {targDir}{default}.c.x {PPCCOptions}


### Build Rules ###

spMpegEncode-ppc      spMpegEncode-ppc.o

spMpegEncode-ppc.o    {ObjFiles-PPC} {LibFiles-PPC} {MondoBuild}
	PPCLink 
		-o {Targ} 
		{ObjFiles-PPC} 
		{LibFiles-PPC} 
		{Sym-PPC} 
		-mf -d 
		-t 'XCOF' 
		-c 'MPS ' 
		-xm l; 
	Duplicate -y {Targ} {SpLibDir}



### Required Dependencies ###

"{ObjDir}mpegEncode.c.x"    mpegEncode.c
"{ObjDir}bladesys.c.x"    :bladeenc:bladesys.c
"{ObjDir}bladtab.c.x"    :bladeenc:bladtab.c
"{ObjDir}common.c.x"    :bladeenc:common.c
"{ObjDir}encode.c.x"    :bladeenc:encode.c
"{ObjDir}formatbitstream2.c.x"    :bladeenc:formatbitstream2.c
"{ObjDir}huffman.c.x"    :bladeenc:huffman.c
"{ObjDir}l3bitstream.c.x"    :bladeenc:l3bitstream.c
"{ObjDir}l3psy.c.x"    :bladeenc:l3psy.c
"{ObjDir}loop.c.x"    :bladeenc:loop.c
"{ObjDir}mdct.c.x"    :bladeenc:mdct.c
"{ObjDir}codec.c.x"    :bladeenc:codec.c
"{ObjDir}reservoir.c.x"    :bladeenc:reservoir.c
"{ObjDir}strupr.c.x"    :bladeenc:strupr.c
"{ObjDir}subs.c.x"    :bladeenc:subs.c
"{ObjDir}tables.c.x"    :bladeenc:tables.c


### Optional Dependencies ###
### Build this target to generate "include file" dependencies. ###

Dependencies    $OutOfDate
	MakeDepend 
		-append {MAKEFILE} 
		-ignore "{CIncludes}" 
		-objdir "{ObjDir}" 
		-objext .x 
		{Includes} 
		{SrcFiles}


