#   File:       libsndfile.make
#   Target:     libsndfile
#   Created:    Tuesday, February 12, 2002 04:19:52 PM


MAKEFILE        = libsndfile.make
# MondoBuild    = {MAKEFILE}  # Make blank to avoid rebuilds when makefile is modified
MondoBuild    =

ObjDir          = ::src:
Includes        =  
				  -i :

Sym-PPC         = -sym off

PPCCOptions     = {Includes} {Sym-PPC} -includes unix -enum int -w 35 -j0 -d GUESS_BIG_ENDIAN=1 -d GUESS_LITTLE_ENDIAN=0

### Source Files ###

SrcFiles        =  
			"::src:G72x:g721.c" 
			"::src:G72x:g723_16.c" 
			"::src:G72x:g723_24.c" 
			"::src:G72x:g723_40.c" 
			"::src:G72x:g72x.c" 
			"::src:GSM610:add.c" 
			"::src:GSM610:code.c" 
			"::src:GSM610:decode.c" 
			"::src:GSM610:gsm_create.c" 
			"::src:GSM610:gsm_decode.c" 
			"::src:GSM610:gsm_destroy.c" 
			"::src:GSM610:gsm_encode.c" 
			"::src:GSM610:gsm_option.c" 
			"::src:GSM610:long_term.c" 
			"::src:GSM610:lpc.c" 
			"::src:GSM610:preprocess.c" 
			"::src:GSM610:rpe.c" 
			"::src:GSM610:short_term.c" 
			"::src:GSM610:table.c" 
			"::src:aiff.c" 
			"::src:alaw.c" 
			"::src:au.c" 
			"::src:au_g72x.c" 
			"::src:common.c" 
			"::src:float32.c" 
			"::src:ircam.c" 
			"::src:nist.c" 
			"::src:paf.c" 
			"::src:pcm.c" 
			"::src:raw.c" 
			"::src:samplitude.c" 
			"::src:sndfile.c" 
			"::src:svx.c" 
			"::src:ulaw.c" 
			"::src:voc.c" 
			"::src:wav.c" 
			"::src:wav_gsm610.c" 
			"::src:wav_ima_adpcm.c" 
			"::src:wav_ms_adpcm.c"


### Object Files ###

ObjFiles-PPC    =  
			"{ObjDir}G72x:g721.c.x" 
			"{ObjDir}G72x:g723_16.c.x" 
			"{ObjDir}G72x:g723_24.c.x" 
			"{ObjDir}G72x:g723_40.c.x" 
			"{ObjDir}G72x:g72x.c.x" 
			"{ObjDir}GSM610:add.c.x" 
			"{ObjDir}GSM610:code.c.x" 
			"{ObjDir}GSM610:decode.c.x" 
			"{ObjDir}GSM610:gsm_create.c.x" 
			"{ObjDir}GSM610:gsm_decode.c.x" 
			"{ObjDir}GSM610:gsm_destroy.c.x" 
			"{ObjDir}GSM610:gsm_encode.c.x" 
			"{ObjDir}GSM610:gsm_option.c.x" 
			"{ObjDir}GSM610:long_term.c.x" 
			"{ObjDir}GSM610:lpc.c.x" 
			"{ObjDir}GSM610:preprocess.c.x" 
			"{ObjDir}GSM610:rpe.c.x" 
			"{ObjDir}GSM610:short_term.c.x" 
			"{ObjDir}GSM610:table.c.x" 
			"{ObjDir}aiff.c.x" 
			"{ObjDir}alaw.c.x" 
			"{ObjDir}au.c.x" 
			"{ObjDir}au_g72x.c.x" 
			"{ObjDir}common.c.x" 
			"{ObjDir}float32.c.x" 
			"{ObjDir}ircam.c.x" 
			"{ObjDir}nist.c.x" 
			"{ObjDir}paf.c.x" 
			"{ObjDir}pcm.c.x" 
			"{ObjDir}raw.c.x" 
			"{ObjDir}samplitude.c.x" 
			"{ObjDir}sndfile.c.x" 
			"{ObjDir}svx.c.x" 
			"{ObjDir}ulaw.c.x" 
			"{ObjDir}voc.c.x" 
			"{ObjDir}wav.c.x" 
			"{ObjDir}wav_gsm610.c.x" 
			"{ObjDir}wav_ima_adpcm.c.x" 
			"{ObjDir}wav_ms_adpcm.c.x"


### Libraries ###

LibFiles-PPC    = 


### Default Rules ###

.c.x    .c  {MondoBuild}
	{PPCC} {depDir}{default}.c -o {targDir}{default}.c.x {PPCCOptions}


### Build Rules ###

libsndfile      libsndfile.o

libsndfile.o    {ObjFiles-PPC} {LibFiles-PPC} {MondoBuild}
	PPCLink 
		-o {Targ} 
		{ObjFiles-PPC} 
		{LibFiles-PPC} 
		{Sym-PPC} 
		-mf -d 
		-t 'XCOF' 
		-c 'MPS ' 
		-xm l



### Required Dependencies ###

"{ObjDir}G72x:g721.c.x"    "::src:G72x:g721.c"
"{ObjDir}G72x:g723_16.c.x"    "::src:G72x:g723_16.c"
"{ObjDir}G72x:g723_24.c.x"    "::src:G72x:g723_24.c"
"{ObjDir}G72x:g723_40.c.x"    "::src:G72x:g723_40.c"
"{ObjDir}G72x:g72x.c.x"    "::src:G72x:g72x.c"
"{ObjDir}GSM610:add.c.x"    "::src:GSM610:add.c"
"{ObjDir}GSM610:code.c.x"    "::src:GSM610:code.c"
"{ObjDir}GSM610:decode.c.x"    "::src:GSM610:decode.c"
"{ObjDir}GSM610:gsm_create.c.x"    "::src:GSM610:gsm_create.c"
"{ObjDir}GSM610:gsm_decode.c.x"    "::src:GSM610:gsm_decode.c"
"{ObjDir}GSM610:gsm_destroy.c.x"    "::src:GSM610:gsm_destroy.c"
"{ObjDir}GSM610:gsm_encode.c.x"    "::src:GSM610:gsm_encode.c"
"{ObjDir}GSM610:gsm_option.c.x"    "::src:GSM610:gsm_option.c"
"{ObjDir}GSM610:long_term.c.x"    "::src:GSM610:long_term.c"
"{ObjDir}GSM610:lpc.c.x"    "::src:GSM610:lpc.c"
"{ObjDir}GSM610:preprocess.c.x"    "::src:GSM610:preprocess.c"
"{ObjDir}GSM610:rpe.c.x"    "::src:GSM610:rpe.c"
"{ObjDir}GSM610:short_term.c.x"    "::src:GSM610:short_term.c"
"{ObjDir}GSM610:table.c.x"    "::src:GSM610:table.c"
"{ObjDir}aiff.c.x"    "::src:aiff.c"
"{ObjDir}alaw.c.x"    "::src:alaw.c"
"{ObjDir}au.c.x"    "::src:au.c"
"{ObjDir}au_g72x.c.x"    "::src:au_g72x.c"
"{ObjDir}common.c.x"    "::src:common.c"
"{ObjDir}float32.c.x"    "::src:float32.c"
"{ObjDir}ircam.c.x"    "::src:ircam.c"
"{ObjDir}nist.c.x"    "::src:nist.c"
"{ObjDir}paf.c.x"    "::src:paf.c"
"{ObjDir}pcm.c.x"    "::src:pcm.c"
"{ObjDir}raw.c.x"    "::src:raw.c"
"{ObjDir}samplitude.c.x"    "::src:samplitude.c"
"{ObjDir}sndfile.c.x"    "::src:sndfile.c"
"{ObjDir}svx.c.x"    "::src:svx.c"
"{ObjDir}ulaw.c.x"    "::src:ulaw.c"
"{ObjDir}voc.c.x"    "::src:voc.c"
"{ObjDir}wav.c.x"    "::src:wav.c"
"{ObjDir}wav_gsm610.c.x"    "::src:wav_gsm610.c"
"{ObjDir}wav_ima_adpcm.c.x"    "::src:wav_ima_adpcm.c"
"{ObjDir}wav_ms_adpcm.c.x"    "::src:wav_ms_adpcm.c"


### Optional Dependencies ###
### Build this target to generate "include file" dependencies. ###

Dependencies    $OutOfDate
	MakeDepend 
		-append {MAKEFILE} 
		-ignore "{CIncludes}" 
		-objdir "{ObjDir}" 
		-objext .x 
		{Includes} 
		{SrcFiles}


