/*
 *	swCursor.h
 */

#ifndef __SWCURSOR_H
#define __SWCURSOR_H

#include "swWindow.h"

#ifdef __cplusplus
extern "C" {
#endif

#if defined(MACOS)
#pragma import on
#endif

extern int swSampToOverviewDisp(swWindow window, long samp);
extern int swSampToDisp(swWindow window, long samp);
extern long swOverviewDispToSamp(swWindow window, int disp);
extern long swDispToSamp(swWindow window, int disp);
extern double swSampToDim(swWindow window, long samp);
extern double swSampToCurrentDim(swWindow window, long samp);
extern long swDimToSamp(swWindow window, double dim);
extern int swDimToDisp(swWindow window, double dim);
extern int swLengthToDisp(swWindow window, long length);
extern long swDispToLength(swWindow window, int disp);
extern void swUpdatePoint(swWindow window, int point, spBool update_flag);
extern void swSetCanvasCursor(spComponent canvas, spCursorType cursor_type);
extern void swSetMouseCursor(swWindow window, spCursorType cursor_type);
extern void swMoveAllCursor(swWindow window);
extern spBool swMoveCursor(swWindow window, long point, spBool update_flag);
extern void swMoveCursorCB(spComponent component, swWindow window);
extern spBool swPlayRegion(swWindow window, long st, long ed);
extern spBool swPlayStop(swWindow window);
extern void swPlayRegionCB(spComponent component, swWindow window);
extern void swLoopPlayRegionCB(spComponent component, swWindow window);
extern void swPlayWindowCB(spComponent component, swWindow window);
extern void swPlayFileCB(spComponent component, swWindow window);
extern void swPlayStopCB(spComponent component, swWindow window);
extern void swButtonMotionCB(spComponent component, swWindow window);
extern void swKeyPressCB(spComponent component, swWindow window);

#if defined(MACOS)
#pragma import off
#endif

#ifdef __cplusplus
}  /* Close scope of 'extern "C"' declaration */
#endif

#endif /* __SWCURSOR_H */
