/*
 *	swDraw.h
 */

#ifndef __SWDRAW_H
#define __SWDRAW_H

#include "swWindow.h"

#ifdef __cplusplus
extern "C" {
#endif

#define SW_REGION_PIXEL_NEGA_INCR -16
#define SW_REGION_PIXEL_POSI_INCR 16
    
typedef struct _swGraphics {
    spGraphics gx_fg;
    spGraphics gx_bg;
    spGraphics gx_xor;
    spGraphics gx_pointer;
    spGraphics gx_string;
    spGraphics gx_label;
    spGraphics gx_region;
    spGraphics gx_region_bg;
    spGraphics gx_scale;
    spGraphics gx_meter;
    spGraphics gx_overview_xor;
    void *mutex;

    spPixel region_pixel;
    spPixel current_region_pixel;
    spPixel region_bg_pixel;
    int region_pixel_incr;
    char region_color[SP_MAX_LINE];
    char region_label_color[SP_MAX_LINE];
    char region_line_color[SP_MAX_LINE];
    char region_bg_color[SP_MAX_LINE];
} *swGraphics;
    
#if defined(MACOS)
#pragma import on
#endif

extern void swSetColor(swConfig config);
extern void swGetDrawRange(swWindow window, int channel, int *draw_min, int *draw_max);
extern int swGetDrawWidth(swWindow window);
extern void swDrawWaveImage(spComponent component, swWindow window, long draw_length);
extern void swDrawWaveImageCB(spComponent component, swWindow window);
extern void swCopyImage(swWindow window);
extern spBool swGetDrawTimeString(swWindow window, double point_f, char *string, spBool align_left);
extern void swDrawString(swWindow window);
extern void swDrawLabels(spComponent component, swWindow window);
extern void swRedrawLabels(swWindow window);
extern void swRedrawLabelsCB(spComponent component, swWindow window);
extern void swUpdateLabels(swWindow window);
extern void swResetRegion(swWindow window);
extern void swSelectRegion(swWindow window, int channel, long start, long end);
extern void swSelectRegionCB(spComponent component, swWindow window);
extern void swSelectFromHereCB(spComponent component, swWindow window);
extern void swSelectToHereCB(spComponent component, swWindow window);
extern void swSelectAllRegionCB(spComponent component, swWindow window);
extern void swSelectAllCB(spComponent component, swWindow window);
extern void swSelectNextChannelCB(spComponent component, swWindow window);
extern void swReverseRegion(swWindow window, int channel, int start_d, int end_d);
extern void swRedrawRegion(swWindow window);
extern void swClearRegion(swWindow window);
extern void swRefreshWindow(swWindow window, spBool draw_cursor);
extern void swDrawCursor(swWindow window);
extern void swReverseOverviewRegion(swWindow window, int channel, int start_d, int end_d);
extern void swUpdateOverview(swWindow window, spBool point_flag,
			     spBool region_flag, spBool refresh_flag);
extern void swDrawOverview(swWindow window);
extern void swDrawWave(swWindow window);
extern void swDrawOverviewCB(spComponent component, swWindow window);
extern void swDrawWaveCB(spComponent component, swWindow window);
extern void swRedrawWave(swWindow window);
extern void swReloadWave(swWindow window, spBool in_thread);
extern void swDrawAllWave(swWindow window);
extern void swAlignWindowCB(spComponent component, swWindow window);
extern void swZoomRegion(swWindow window, long offset, long length, spBool in_thread);
extern void swZoomRegionCB(spComponent component, swWindow window);
extern void swZoomInCB(spComponent component, swWindow window);
extern void swZoomOutCB(spComponent component, swWindow window);
extern void swZoomFullOutCB(spComponent component, swWindow window);
extern spBool swScrollWindow(swWindow window, long offset, spBool move_cursor, spBool in_thread);
extern void swScrollCB(spComponent component, swWindow window);
extern void swForwardCB(spComponent component, swWindow window);
extern void swBackwardCB(spComponent component, swWindow window);
extern void swGoHeadCB(spComponent component, swWindow window);
extern void swGoTailCB(spComponent component, swWindow window);
extern void swNextWindowCB(spComponent component, swWindow window);
extern void swPrevWindowCB(spComponent component, swWindow window);

#if defined(MACOS)
#pragma import off
#endif

#ifdef __cplusplus
}  /* Close scope of 'extern "C"' declaration */
#endif

#endif /* __SWDRAW_H */
