/*
 *	swInfoDialog.h
 */

#ifndef __SWINFODIALOG_H
#define __SWINFODIALOG_H

#include "swWindow.h"

#ifdef __cplusplus
extern "C" {
#endif

#ifdef SW_SUPPORT_INFO_DIALOG

typedef struct _swInfoDialog {
    spComponent window;
    spComponent container;
    
    spComponent title_text;
    spComponent artist_text;
    spComponent album_text;
    spComponent genre_text;
    spComponent release_text;
    spComponent track_text;
    spComponent copyright_text;
    spComponent engineer_text;
    spComponent source_text;
    spComponent software_text;
    spComponent subject_text;
    spComponent comment_text;
    
    swConfig config;
} *swInfoDialog;

#if defined(MACOS)
#pragma import on
#endif

extern swInfoDialog swCreateInfoDialog(swConfig config);
extern void swPopupInfoDialogCB(spComponent component, swWindow window);
extern void swPopdownInfoDialogCB(spComponent component, swInfoDialog dialog);
    
#if defined(MACOS)
#pragma import off
#endif

#endif

#ifdef __cplusplus
}  /* Close scope of 'extern "C"' declaration */
#endif

#endif /* __SWINFODIALOG_H */
